__xml__() case "${1}"
in (--version) echo VERSION: 0.3
;; (-h | --help | help ) <<% cat

So far, UTSL:

	* the @ (ATTRIBUTES) section of this file is the reference
	  for all expansions (t/xml.sh provide examples)
	* WEB.sh is the place where the html functions are declared,
	  you can use it as example.
	* if you write your own (like XSLT.sh), please let us know

TODO

	see WEB.sh TODO:

CHANGES

	v0.2 support of XMLPRX
	v0.3 lil moar doc

EXAMPLES

XML source from https://edutechwiki.unige.ch/fr/Tutoriel_pour_g%C3%A9n%C3%A9rer_du_SVG_avec_du_XSLT

	<xsl:variable name ="y_steps">
	<xsl:for-each select="//list/item">
	<xsl:sort select="." data-type="number" order="descending"/>
	<xsl:if test="position() = 1">
	<xsl:value-of select="($svg_height - 2*$padding) div ."/>
	</xsl:if>
	</xsl:for-each>
	</xsl:variable>
	<xsl:template match="item">

translation to XML.sh

	. XML.sh
	# those 2 lines are meant to live in XSLT.sh
	XMLNS=xsl XMLPRX=t __xml__ nodes variable each=for-each sort if val=value-of
	XMLNS=xsl XMLPRX=t __xml__ leaves t
	# this is the actual code
	(t_variable 'name y_steps'
		(t_each 'select //list/item'
			(t_sort 'data-type number' 'order descending')
			(t_if 'test position() = 1'
				(t_val 'select ($vg_heigth - 2*$padding) div .'))))

example web usage

web is sh + XML.sh + WEB.sh so you can write

	<<% web
	title="hello world"
	__html 'lang fr'
		(title % "$title" )
	__body
		(header
			(nav; printf '<li><a href="%s">%s</a></li>' \
			/      "homepage"               \
			/about/ "self promotion"        \
			/code/ "readings for computers" \
			/articles/ "readings for humans"
			)
		)
		(article)
		(h1 +first )

AKNOWLEDGEMENT

I'm wondering if the web command is actually the catium core
(and should be renamed catium)

%
;; (@) shift ; # ATTRIBUTES
	while ! [ $# = 0 ] ; do case "${1}"
		in ( .*    )         printf ' class="%s"' "${1#?}"
		;; ( +*    )         printf ' id="%s"' "${1#?}"
		;; ( \$    ) shift ; printf '>$%s'       "${1:-$it}"  ; return
		;; ( !     ) shift ; printf '>$(%s)'            "$*"  ; return
		;; ( %     ) shift ; printf '>%s'               "$*"  ; return
		;; ( %%    ) shift ; printf '><![CDATA[%s]]>'   "$*"  ; return
		;; ( %$    ) shift ; printf '><![CDATA[$%s]]>'  "$*"  ; return
		;; ( /     )         echo -n '/>' ; return
		;; ( *\ *  )         printf ' %s="%s"' "${1%% *}" "${1#* }"
		;; ( *     )         printf ' %s' "$1"
		esac
		shift
	done
	printf '>'
;; (node) printf "<$2"
	trap "printf '</$2>'" EXIT
;; ( nodes | mknodes) shift; for it; do
		t=${XMLNS+$XMLNS:}${it#*=}
		eval "${XMLPRX+${XMLPRX}_}${it%=*}() {
			it=$t
			__xml__ node $t
			__xml__ @ "' "$@" ; }'
	done
;; ( leaves | mkleaves) shift; for it; do
		t=${XMLNS+$XMLNS:}${it#*=}
		eval "${XMLPRX+${XMLPRX}_}${it%=*}() {
			echo -n '<$t'
			__xml__ @ "' "$@" /
			}'
	done
;; (v1.0utf8 ) printf '<?xml version="1.0" encoding="utf-8"?>'
;; (v1.0     ) printf '<?xml version="1.0"?>'
;; (*) >&2 echo "there is no $1 subcommand"
esac


hook() printf '${hook_%s+$($hook_%s)}' "$1" "$1"
chomp() tr -d '\n'

# ifdef would be great if we fix its quoting problem
# (only when template generation)
ifdef() {
	it="\$$1"
	printf '${%s+' "$1"
	trap "printf '}'" EXIT
}

# Example from doc was
# alias +=ifdef
# (+ ${v=description}
# 	meta description $it
# 	(+ social
# 		meta \
# 		:og:descrition      \$$v \
# 		@twitter:descrition \$$v ))

# which lead to unprotected quotes *inside* an interpolation
# so those quotes are signifiant again
#
# description="cool thing to know" social=true
# <<% htmlq --pretty
# ${description+<meta name="description" content="$description"/>${social+<meta name=":og:descrition" content="$description"/><meta name="@twitter:descrition" content="$description"/>}}
#
# a way to fix it is to create variable.
# another way could be to metaquote (from the +) but this isn't
# shell anymore (at least sed. maybe C?)



