#! /bin/sh

# Je ne sais plus comment j'ai obtenu `/net/wifi/unistra.pem`. Je viens de télécharger
# `eduroam-linux-UdS-Eduroam_Osiris_Strasbourg.py` depuis [eduroam](https://cat.eduroam.org/).
# les certificats sont en dur dans le code et peuvent être extraits avec:
#
# 	sed '/^Config.CA /,/"""/!d' |
# 	sed '1s/.*"""//;$d'
#
# Dites moi si ça fonctionne.
#
#
# Victor H. m'a proposé un lien vers [une version OpenBSD](https://astro-gr.org/openbsd-eduroam/)
# du même script.

# $LOGIN and $PASSWORD from
. ~/net/secrets/unistra # this file should be crypted!

ip li set wlan0 up
killall wpa_supplicant # less brutal way to do it ?
dhclient -r wlan0

<<-% wpa_supplicant -i wlan0 -dd -c /dev/stdin -f /net/wifi/log & dhclient wlan0
network={
	ssid="eduroam"
	key_mgmt=WPA-EAP
	pairwise=CCMP
	group=CCMP TKIP
	eap=TTLS
	ca_cert="/net/wifi/unistra.pem"
	identity="$LOGIN"
	altsubject_match="DNS:auth.u-strasbg.fr"
	phase2="auth=PAP"
	password="$PASSWORD"
	anonymous_identity="anonymous@unistra.fr"
}
